Subject: bug#35055: 27.0.50; async-shell-command truncates output lines

From: Juri Linkov <[email-masked]>
Date: Sat, 06 Apr 2019 23:47:34 +0300

>>>> That's because Tramp sets process property `adjust-window-size-function'
>>>> to `ignore' (and not to nil as I wrote above). This was 2 years ago;
>>>> unfortunately, I have neither a bug nor a message reference for that change.
>>>
>>> Then I don't understand why remote shell output is limited to 80 columns
>>> when Tramp sets `adjust-window-size-function' to `ignore', i.e. not to 80.
>>
>> We could add a new defcustom process-window-width with a choice of
>> a numeric value to set COLUMNS env variable in the process, or
>> a symbol `window-width' to set COLUMNS to the width of the output
>> buffer's window.  Then it will handle both asynchronous processes
>> and synchronous remote shell commands as well.
>
> Would be possible. However, I wouldn't speak about COLUMNS of the
> underlying process, because this is implementation detail. For remote
> processes the process object you see is related to the *local* process
> Tramp has opened. But we want to influence the *remote* process, which
> has been started from the local process via ssh (for example).
>
> The following code snippet does this already (with an example value of
> 1024 chars for the width)
>
> (defun set-fixed-process-window-width ()
>   (let ((proc (get-buffer-process (current-buffer))))
>     (set-process-window-size proc (window-body-height (selected-window)) 1024)
>     ;; Don't change size when Emacs window changes.
>     (process-put proc 'adjust-window-size-function #'ignore)))
>
> (add-hook 'shell-mode-hook 'set-fixed-process-window-width)
>
>
> You can test it like this, for example
>
> (shell-command-to-string "ps aux")
> (shell-command-to-string "ps aux &")
>
>
> or in a shell
>
> M-x shell
> ## in the *shell* buffer
> $ echo $COLUMNS
> 1024

I didn't know that set-process-window-size changes the
value of COLUMNS.  I thought that COLUMNS is set only by
comint-term-environment.  One thing I still don't understand is
how it would be possible to do the same for the remote process?